<?php
include_once(getabspath("classes/printpage.php"));

function DisplayMasterTableInfoForPrint_electricity($params)
{
	global $cman;
	
	$detailtable = $params["detailtable"];
	$keys = $params["keys"];
	
	$xt = new Xtempl();
	
	$tName = "electricity";
	$xt->eventsObject = getEventObject($tName);
	
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["pageType"] = PAGE_PRINT;
	$mParams["tName"] = $tName;
	$masterPage = new PrintPage($mParams);
	
	$cipherer = new RunnerCipherer( $tName );
	$settings = new ProjectSettings($tName, PAGE_PRINT);
	$connection = $cman->byTable( $tName );
	
	$masterQuery = $settings->getSQLQuery();
	$viewControls = new ViewControlsContainer($settings, PAGE_PRINT, $masterPage);
	
	$where = "";
	$keysAssoc = array();
	$showKeys = "";

	if( $detailtable == "electricity_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("electricity","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}

	if( $detailtable == "electricity_charges" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("electricity","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}
	
	if( !$where )
		return;
	
	$str = SecuritySQL("Export", $tName );
	if( strlen($str) )
		$where.= " and ".$str;
	
	$strWhere = whereAdd( $masterQuery->m_where->toSql($masterQuery), $where );
	if( strlen($strWhere) )
		$strWhere= " where ".$strWhere." ";
		
	$strSQL = $masterQuery->HeadToSql().' '.$masterQuery->FromToSql().$strWhere.$masterQuery->TailToSql();
	LogInfo($strSQL);
	
	$data = $cipherer->DecryptFetchedArray( $connection->query( $strSQL )->fetchAssoc() );
	if( !$data )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));	
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["id"]));
	
	$xt->assign("Print_mastervalue", $viewControls->showDBValue("Print", $data, $keylink));
	$format = $settings->getViewFormat("Print");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Print")))
		$class = ' rnr-field-number';
		
	$xt->assign("Print_class", $class); // add class for field header as field value
	$xt->assign("id_mastervalue", $viewControls->showDBValue("id", $data, $keylink));
	$format = $settings->getViewFormat("id");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("id")))
		$class = ' rnr-field-number';
		
	$xt->assign("id_class", $class); // add class for field header as field value
	$xt->assign("date_mastervalue", $viewControls->showDBValue("date", $data, $keylink));
	$format = $settings->getViewFormat("date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("date")))
		$class = ' rnr-field-number';
		
	$xt->assign("date_class", $class); // add class for field header as field value
	$xt->assign("start_date_mastervalue", $viewControls->showDBValue("start_date", $data, $keylink));
	$format = $settings->getViewFormat("start_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("start_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("start_date_class", $class); // add class for field header as field value
	$xt->assign("end_date_mastervalue", $viewControls->showDBValue("end_date", $data, $keylink));
	$format = $settings->getViewFormat("end_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("end_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("end_date_class", $class); // add class for field header as field value
	$xt->assign("GENERATION_CHARGE_mastervalue", $viewControls->showDBValue("GENERATION CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("GENERATION CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("GENERATION CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("GENERATION_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("VAT_FOR_GEN__CHARGE_mastervalue", $viewControls->showDBValue("VAT FOR GEN. CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("VAT FOR GEN. CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("VAT FOR GEN. CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("VAT_FOR_GEN__CHARGE_class", $class); // add class for field header as field value
	$xt->assign("PREV_MOS_ADJ__ON_GEN__COST_mastervalue", $viewControls->showDBValue("PREV MOS ADJ. ON GEN. COST", $data, $keylink));
	$format = $settings->getViewFormat("PREV MOS ADJ. ON GEN. COST");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("PREV MOS ADJ. ON GEN. COST")))
		$class = ' rnr-field-number';
		
	$xt->assign("PREV_MOS_ADJ__ON_GEN__COST_class", $class); // add class for field header as field value
	$xt->assign("VAT_PREV_MOS_ADJ__ON_GEN__COST_mastervalue", $viewControls->showDBValue("VAT PREV MOS ADJ. ON GEN. COST", $data, $keylink));
	$format = $settings->getViewFormat("VAT PREV MOS ADJ. ON GEN. COST");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("VAT PREV MOS ADJ. ON GEN. COST")))
		$class = ' rnr-field-number';
		
	$xt->assign("VAT_PREV_MOS_ADJ__ON_GEN__COST_class", $class); // add class for field header as field value
	$xt->assign("PREV_YEARS_ADJUSTMENT_mastervalue", $viewControls->showDBValue("PREV YEARS ADJUSTMENT", $data, $keylink));
	$format = $settings->getViewFormat("PREV YEARS ADJUSTMENT");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("PREV YEARS ADJUSTMENT")))
		$class = ' rnr-field-number';
		
	$xt->assign("PREV_YEARS_ADJUSTMENT_class", $class); // add class for field header as field value
	$xt->assign("TRANSMISSION_CHARGE__VAT__mastervalue", $viewControls->showDBValue("TRANSMISSION CHARGE (VAT)", $data, $keylink));
	$format = $settings->getViewFormat("TRANSMISSION CHARGE (VAT)");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("TRANSMISSION CHARGE (VAT)")))
		$class = ' rnr-field-number';
		
	$xt->assign("TRANSMISSION_CHARGE__VAT__class", $class); // add class for field header as field value
	$xt->assign("VAT_FOR_TRANSMISSION_CHARGE_mastervalue", $viewControls->showDBValue("VAT FOR TRANSMISSION CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("VAT FOR TRANSMISSION CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("VAT FOR TRANSMISSION CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("VAT_FOR_TRANSMISSION_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("SYSTEM_LOSS_CHARGE_mastervalue", $viewControls->showDBValue("SYSTEM LOSS CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("SYSTEM LOSS CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("SYSTEM LOSS CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("SYSTEM_LOSS_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("VAT_FOR_SL_CHARGE_mastervalue", $viewControls->showDBValue("VAT FOR SL CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("VAT FOR SL CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("VAT FOR SL CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("VAT_FOR_SL_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("ENERGY_CHARGE_mastervalue", $viewControls->showDBValue("ENERGY CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("ENERGY CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("ENERGY CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("ENERGY_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("DEMAND_CHARGE_mastervalue", $viewControls->showDBValue("DEMAND CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("DEMAND CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("DEMAND CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("DEMAND_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("SUPPLY_CHARGE_mastervalue", $viewControls->showDBValue("SUPPLY CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("SUPPLY CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("SUPPLY CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("SUPPLY_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("METERING_CHARGE_mastervalue", $viewControls->showDBValue("METERING CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("METERING CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("METERING CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("METERING_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("CERA_REFUND_mastervalue", $viewControls->showDBValue("CERA REFUND", $data, $keylink));
	$format = $settings->getViewFormat("CERA REFUND");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("CERA REFUND")))
		$class = ' rnr-field-number';
		
	$xt->assign("CERA_REFUND_class", $class); // add class for field header as field value
	$xt->assign("POWER_FACTOR_ADJUSTMENT_mastervalue", $viewControls->showDBValue("POWER FACTOR ADJUSTMENT", $data, $keylink));
	$format = $settings->getViewFormat("POWER FACTOR ADJUSTMENT");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("POWER FACTOR ADJUSTMENT")))
		$class = ' rnr-field-number';
		
	$xt->assign("POWER_FACTOR_ADJUSTMENT_class", $class); // add class for field header as field value
	$xt->assign("LIFELINE_RATE_SUBSIDY_mastervalue", $viewControls->showDBValue("LIFELINE RATE SUBSIDY", $data, $keylink));
	$format = $settings->getViewFormat("LIFELINE RATE SUBSIDY");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("LIFELINE RATE SUBSIDY")))
		$class = ' rnr-field-number';
		
	$xt->assign("LIFELINE_RATE_SUBSIDY_class", $class); // add class for field header as field value
	$xt->assign("CROSS_SUBSIDY_CHARGE_mastervalue", $viewControls->showDBValue("CROSS SUBSIDY CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("CROSS SUBSIDY CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("CROSS SUBSIDY CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("CROSS_SUBSIDY_CHARGE_class", $class); // add class for field header as field value
	$xt->assign("LOCAL_FRANCHISE_TAX_mastervalue", $viewControls->showDBValue("LOCAL FRANCHISE TAX", $data, $keylink));
	$format = $settings->getViewFormat("LOCAL FRANCHISE TAX");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("LOCAL FRANCHISE TAX")))
		$class = ' rnr-field-number';
		
	$xt->assign("LOCAL_FRANCHISE_TAX_class", $class); // add class for field header as field value
	$xt->assign("VAT_FOR_DIST____SUBS_mastervalue", $viewControls->showDBValue("VAT FOR DIST. & SUBS", $data, $keylink));
	$format = $settings->getViewFormat("VAT FOR DIST. & SUBS");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("VAT FOR DIST. & SUBS")))
		$class = ' rnr-field-number';
		
	$xt->assign("VAT_FOR_DIST____SUBS_class", $class); // add class for field header as field value
	$xt->assign("FIT_ALL__RENEWABLE__mastervalue", $viewControls->showDBValue("FIT-ALL (RENEWABLE)", $data, $keylink));
	$format = $settings->getViewFormat("FIT-ALL (RENEWABLE)");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("FIT-ALL (RENEWABLE)")))
		$class = ' rnr-field-number';
		
	$xt->assign("FIT_ALL__RENEWABLE__class", $class); // add class for field header as field value
	$xt->assign("MISSIONARY_mastervalue", $viewControls->showDBValue("MISSIONARY", $data, $keylink));
	$format = $settings->getViewFormat("MISSIONARY");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("MISSIONARY")))
		$class = ' rnr-field-number';
		
	$xt->assign("MISSIONARY_class", $class); // add class for field header as field value
	$xt->assign("ENVIRONMENTAL_FUND_mastervalue", $viewControls->showDBValue("ENVIRONMENTAL FUND", $data, $keylink));
	$format = $settings->getViewFormat("ENVIRONMENTAL FUND");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("ENVIRONMENTAL FUND")))
		$class = ' rnr-field-number';
		
	$xt->assign("ENVIRONMENTAL_FUND_class", $class); // add class for field header as field value
	$xt->assign("NPC_STRANDED_CONTRACT_COSTS_mastervalue", $viewControls->showDBValue("NPC STRANDED CONTRACT COSTS", $data, $keylink));
	$format = $settings->getViewFormat("NPC STRANDED CONTRACT COSTS");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("NPC STRANDED CONTRACT COSTS")))
		$class = ' rnr-field-number';
		
	$xt->assign("NPC_STRANDED_CONTRACT_COSTS_class", $class); // add class for field header as field value
	$xt->assign("TRANSMISSION_CHARGE_mastervalue", $viewControls->showDBValue("TRANSMISSION CHARGE", $data, $keylink));
	$format = $settings->getViewFormat("TRANSMISSION CHARGE");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("TRANSMISSION CHARGE")))
		$class = ' rnr-field-number';
		
	$xt->assign("TRANSMISSION_CHARGE_class", $class); // add class for field header as field value

	$layout = GetPageLayout("electricity", 'masterprint');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');

	$xt->displayPartial(GetTemplateName("electricity", "masterprint"));
}

?>