<?php

/**
* getLookupMainTableSettings - tests whether the lookup link exists between the tables
*
*  returns array with ProjectSettings class for main table if the link exists in project settings.
*  returns NULL otherwise
*/
function getLookupMainTableSettings($lookupTable, $mainTableShortName, $mainField, $desiredPage = "")
{
	global $lookupTableLinks;
	if(!isset($lookupTableLinks[$lookupTable]))
		return null;
	if(!isset($lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField]))
		return null;
	$arr = &$lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField];
	$effectivePage = $desiredPage;
	if(!isset($arr[$effectivePage]))
	{
		$effectivePage = PAGE_EDIT;
		if(!isset($arr[$effectivePage]))
		{
			if($desiredPage == "" && 0 < count($arr))
			{
				$effectivePage = $arr[0];
			}
			else
				return null;
		}
	}
	return new ProjectSettings($arr[$effectivePage]["table"], $effectivePage);
}

/** 
* $lookupTableLinks array stores all lookup links between tables in the project
*/
function InitLookupLinks()
{
	global $lookupTableLinks;

	$lookupTableLinks = array();

	$lookupTableLinks["stall_tenant"]["electricity_detail.stall_no"]["edit"] = array("table" => "electricity_detail", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["electricity_detail.tenant"]["edit"] = array("table" => "electricity_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["gas_detail.stall_no"]["edit"] = array("table" => "gas_detail", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["gas_detail.tenant"]["edit"] = array("table" => "gas_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["vat_type"]["gas_detail.vat_type"]["edit"] = array("table" => "gas_detail", "field" => "vat_type", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["water_detail.stall_no"]["edit"] = array("table" => "water_detail", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["water_detail.tenant"]["edit"] = array("table" => "water_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["vat_type"]["water_detail.vat_type"]["edit"] = array("table" => "water_detail", "field" => "vat_type", "page" => "edit");
	$lookupTableLinks["stall"]["rent.stall"]["edit"] = array("table" => "rent", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["rent.tenant"]["edit"] = array("table" => "rent", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["reservation_type"]["rent.reservation"]["edit"] = array("table" => "rent", "field" => "reservation", "page" => "edit");
	$lookupTableLinks["discounts"]["rent.discount"]["edit"] = array("table" => "rent", "field" => "discount", "page" => "edit");
	$lookupTableLinks["cost_center"]["rent.center"]["edit"] = array("table" => "rent", "field" => "center", "page" => "edit");
	$lookupTableLinks["floor"]["stall.floor"]["edit"] = array("table" => "stall", "field" => "floor", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["cusa.stall"]["edit"] = array("table" => "cusa", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["cusa.tenant"]["edit"] = array("table" => "cusa", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["discount1"]["cusa.discount"]["edit"] = array("table" => "cusa", "field" => "discount", "page" => "edit");
	$lookupTableLinks["bal_water"]["payment_detail_water.ref_id"]["edit"] = array("table" => "payment_detail_water", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["bal_gas"]["payment_detail_gas.ref_id"]["edit"] = array("table" => "payment_detail_gas", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["bal_electricity"]["payment_detail_electricity.ref_id"]["edit"] = array("table" => "payment_detail_electricity", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["bal_cusa"]["payment_detail_cusa.ref_id"]["edit"] = array("table" => "payment_detail_cusa", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["tenant"]["rent_detail.tenant"]["edit"] = array("table" => "rent_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["CUSA_for_billing.stall"]["edit"] = array("table" => "CUSA_for_billing", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["CUSA_for_billing.tenant"]["edit"] = array("table" => "CUSA_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["electricity_for_billing.stall_no"]["edit"] = array("table" => "electricity_for_billing", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["electricity_for_billing.tenant"]["edit"] = array("table" => "electricity_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["Gas_for_billing.stall_no"]["edit"] = array("table" => "Gas_for_billing", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["Gas_for_billing.tenant"]["edit"] = array("table" => "Gas_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["Rent_for_billing.stall"]["edit"] = array("table" => "Rent_for_billing", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Rent_for_billing.tenant"]["edit"] = array("table" => "Rent_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["Water_for_billing.stall_no"]["edit"] = array("table" => "Water_for_billing", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["Water_for_billing.tenant"]["edit"] = array("table" => "Water_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["rent_payment.stall"]["edit"] = array("table" => "rent_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["rent_payment.tenant"]["edit"] = array("table" => "rent_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["CUSA_payment.stall"]["edit"] = array("table" => "CUSA_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["CUSA_payment.tenant"]["edit"] = array("table" => "CUSA_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["Gas_payment.stall"]["edit"] = array("table" => "Gas_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Gas_payment.tenant"]["edit"] = array("table" => "Gas_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["Electricity_payment.stall"]["edit"] = array("table" => "Electricity_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Electricity_payment.tenant"]["edit"] = array("table" => "Electricity_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["Water_payment.stall"]["edit"] = array("table" => "Water_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Water_payment.tenant"]["edit"] = array("table" => "Water_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["bal_rent"]["payment_detail_rent.ref_id"]["edit"] = array("table" => "payment_detail_rent", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["stall"]["Rent_Summary.stall"]["search"] = array("table" => "Rent_Summary", "field" => "stall", "page" => "search");
	$lookupTableLinks["tenant"]["Rent_Summary.tenant"]["search"] = array("table" => "Rent_Summary", "field" => "tenant", "page" => "search");
	$lookupTableLinks["reservation_type"]["Rent_Summary.reservation"]["search"] = array("table" => "Rent_Summary", "field" => "reservation", "page" => "search");
	$lookupTableLinks["discount1"]["Rent_Summary.discount"]["search"] = array("table" => "Rent_Summary", "field" => "discount", "page" => "search");
	$lookupTableLinks["stall"]["rent_contract.stall"]["search"] = array("table" => "rent_contract", "field" => "stall", "page" => "search");
	$lookupTableLinks["tenant"]["rent_contract.tenant"]["search"] = array("table" => "rent_contract", "field" => "tenant", "page" => "search");
	$lookupTableLinks["reservation_type"]["rent_contract.reservation"]["search"] = array("table" => "rent_contract", "field" => "reservation", "page" => "search");
	$lookupTableLinks["discount1"]["rent_contract.discount"]["search"] = array("table" => "rent_contract", "field" => "discount", "page" => "search");
	$lookupTableLinks["stall_tenant"]["electricity_charges.stall_no"]["edit"] = array("table" => "electricity_charges", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["electricity_charges.tenant"]["edit"] = array("table" => "electricity_charges", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["tenant"]["journal_entry_rent_contract.tenant"]["edit"] = array("table" => "journal_entry_rent_contract", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["tenant"]["journal_entry_rent_amortization.tenant"]["edit"] = array("table" => "journal_entry_rent_amortization", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_rent_amortization.unearned_rental_income"]["edit"] = array("table" => "journal_entry_rent_amortization", "field" => "unearned_rental_income", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_rent_amortization.uri_NAME"]["edit"] = array("table" => "journal_entry_rent_amortization", "field" => "uri_NAME", "page" => "edit");
	$lookupTableLinks["tenant"]["journal_entry_electricity_billing.Business_Partner"]["edit"] = array("table" => "journal_entry_electricity_billing", "field" => "Business_Partner", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_electricity_billing.acc_no"]["edit"] = array("table" => "journal_entry_electricity_billing", "field" => "acc_no", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_electricity_billing.acc_name"]["edit"] = array("table" => "journal_entry_electricity_billing", "field" => "acc_name", "page" => "edit");
	$lookupTableLinks["tenant"]["sales_rental.Business_Partner"]["edit"] = array("table" => "sales_rental", "field" => "Business_Partner", "page" => "edit");
	$lookupTableLinks["currency"]["sales_rental.currency"]["edit"] = array("table" => "sales_rental", "field" => "currency", "page" => "edit");
	$lookupTableLinks["cost_center"]["sales_rental.Cost_Center"]["edit"] = array("table" => "sales_rental", "field" => "Cost_Center", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["sales_rental_detail.Account"]["edit"] = array("table" => "sales_rental_detail", "field" => "Account", "page" => "edit");
	$lookupTableLinks["item"]["sales_rental_detail.Description"]["edit"] = array("table" => "sales_rental_detail", "field" => "Description", "page" => "edit");
	$lookupTableLinks["vat_type"]["sales_rental_detail.VAT_Type"]["edit"] = array("table" => "sales_rental_detail", "field" => "VAT_Type", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["sales_rental_detail.account_no"]["edit"] = array("table" => "sales_rental_detail", "field" => "account_no", "page" => "edit");
	$lookupTableLinks["electricity_charges"]["sales_rental_detail.ref_elec"]["edit"] = array("table" => "sales_rental_detail", "field" => "ref_elec", "page" => "edit");
	$lookupTableLinks["gas_detail"]["sales_rental_detail.ref_gas"]["edit"] = array("table" => "sales_rental_detail", "field" => "ref_gas", "page" => "edit");
	$lookupTableLinks["water_detail"]["sales_rental_detail.ref_water"]["edit"] = array("table" => "sales_rental_detail", "field" => "ref_water", "page" => "edit");
	$lookupTableLinks["rent"]["sales_rental_detail.ref_rent"]["edit"] = array("table" => "sales_rental_detail", "field" => "ref_rent", "page" => "edit");
	$lookupTableLinks["rent"]["sales_rental_detail.ref_advance"]["edit"] = array("table" => "sales_rental_detail", "field" => "ref_advance", "page" => "edit");
	$lookupTableLinks["cost_center"]["sales_rental_detail.Cost_Center"]["edit"] = array("table" => "sales_rental_detail", "field" => "Cost_Center", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_billing_rental.Receivable_Account"]["edit"] = array("table" => "journal_entry_billing_rental", "field" => "Receivable_Account", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_billing_rental.Account No"]["edit"] = array("table" => "journal_entry_billing_rental", "field" => "Account No", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_billing_rental.Account_Name"]["edit"] = array("table" => "journal_entry_billing_rental", "field" => "Account_Name", "page" => "edit");
	$lookupTableLinks["tenant"]["cash_receipt_rental.Business_Partner"]["edit"] = array("table" => "cash_receipt_rental", "field" => "Business_Partner", "page" => "edit");
	$lookupTableLinks["cost_center"]["cash_receipt_rental.Cost_Center"]["edit"] = array("table" => "cash_receipt_rental", "field" => "Cost_Center", "page" => "edit");
	$lookupTableLinks["bank"]["cash_receipt_rental.bank"]["edit"] = array("table" => "cash_receipt_rental", "field" => "bank", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["cash_receipt_rental.Cash_Account"]["edit"] = array("table" => "cash_receipt_rental", "field" => "Cash_Account", "page" => "edit");
	$lookupTableLinks["sales_rental"]["cash_receipt_detail_rental.si"]["edit"] = array("table" => "cash_receipt_detail_rental", "field" => "si", "page" => "edit");
	$lookupTableLinks["bal_cashreceipt_rental"]["cash_receipt_detail_rental.ref_id_rental"]["edit"] = array("table" => "cash_receipt_detail_rental", "field" => "ref_id_rental", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["journal_entry_rent_collection.Cash_Account"]["edit"] = array("table" => "journal_entry_rent_collection", "field" => "Cash_Account", "page" => "edit");
	$lookupTableLinks["tenant"]["journal_entry_rent_collection.Business_Partner"]["edit"] = array("table" => "journal_entry_rent_collection", "field" => "Business_Partner", "page" => "edit");
	$lookupTableLinks["chart_of_accounts"]["cash_receipt_detail2_rental.Account"]["edit"] = array("table" => "cash_receipt_detail2_rental", "field" => "Account", "page" => "edit");
	$lookupTableLinks["item"]["cash_receipt_detail2_rental.Description"]["edit"] = array("table" => "cash_receipt_detail2_rental", "field" => "Description", "page" => "edit");
	$lookupTableLinks["vat_type"]["cash_receipt_detail2_rental.VAT_Type"]["edit"] = array("table" => "cash_receipt_detail2_rental", "field" => "VAT_Type", "page" => "edit");
	$lookupTableLinks["cost_center"]["cash_receipt_detail2_rental.Cost_Center"]["edit"] = array("table" => "cash_receipt_detail2_rental", "field" => "Cost_Center", "page" => "edit");
}

?>