<?php
include_once(getabspath("classes/printpage.php"));

function DisplayMasterTableInfoForPrint_rent($params)
{
	global $cman;
	
	$detailtable = $params["detailtable"];
	$keys = $params["keys"];
	
	$xt = new Xtempl();
	
	$tName = "rent";
	$xt->eventsObject = getEventObject($tName);
	
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["pageType"] = PAGE_PRINT;
	$mParams["tName"] = $tName;
	$masterPage = new PrintPage($mParams);
	
	$cipherer = new RunnerCipherer( $tName );
	$settings = new ProjectSettings($tName, PAGE_PRINT);
	$connection = $cman->byTable( $tName );
	
	$masterQuery = $settings->getSQLQuery();
	$viewControls = new ViewControlsContainer($settings, PAGE_PRINT, $masterPage);
	
	$where = "";
	$keysAssoc = array();
	$showKeys = "";

	if( $detailtable == "rent_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("rent","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}

	if( $detailtable == "rent_pdc_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("rent","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}

	if( $detailtable == "journal_entry_rent_contract" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("rent","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}

	if( $detailtable == "journal_entry_rent_amortization" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("rent","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}
	
	if( !$where )
		return;
	
	$str = SecuritySQL("Export", $tName );
	if( strlen($str) )
		$where.= " and ".$str;
	
	$strWhere = whereAdd( $masterQuery->m_where->toSql($masterQuery), $where );
	if( strlen($strWhere) )
		$strWhere= " where ".$strWhere." ";
		
	$strSQL = $masterQuery->HeadToSql().' '.$masterQuery->FromToSql().$strWhere.$masterQuery->TailToSql();
	LogInfo($strSQL);
	
	$data = $cipherer->DecryptFetchedArray( $connection->query( $strSQL )->fetchAssoc() );
	if( !$data )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));	
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["id"]));
	
	$xt->assign("id_mastervalue", $viewControls->showDBValue("id", $data, $keylink));
	$format = $settings->getViewFormat("id");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("id")))
		$class = ' rnr-field-number';
		
	$xt->assign("id_class", $class); // add class for field header as field value
	$xt->assign("si_no_mastervalue", $viewControls->showDBValue("si_no", $data, $keylink));
	$format = $settings->getViewFormat("si_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("si_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("si_no_class", $class); // add class for field header as field value
	$xt->assign("date_mastervalue", $viewControls->showDBValue("date", $data, $keylink));
	$format = $settings->getViewFormat("date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("date")))
		$class = ' rnr-field-number';
		
	$xt->assign("date_class", $class); // add class for field header as field value
	$xt->assign("start_date_mastervalue", $viewControls->showDBValue("start_date", $data, $keylink));
	$format = $settings->getViewFormat("start_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("start_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("start_date_class", $class); // add class for field header as field value
	$xt->assign("end_date_mastervalue", $viewControls->showDBValue("end_date", $data, $keylink));
	$format = $settings->getViewFormat("end_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("end_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("end_date_class", $class); // add class for field header as field value
	$xt->assign("stall_mastervalue", $viewControls->showDBValue("stall", $data, $keylink));
	$format = $settings->getViewFormat("stall");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("stall")))
		$class = ' rnr-field-number';
		
	$xt->assign("stall_class", $class); // add class for field header as field value
	$xt->assign("tenant_mastervalue", $viewControls->showDBValue("tenant", $data, $keylink));
	$format = $settings->getViewFormat("tenant");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("tenant")))
		$class = ' rnr-field-number';
		
	$xt->assign("tenant_class", $class); // add class for field header as field value
	$xt->assign("electricity_mastervalue", $viewControls->showDBValue("electricity", $data, $keylink));
	$format = $settings->getViewFormat("electricity");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("electricity")))
		$class = ' rnr-field-number';
		
	$xt->assign("electricity_class", $class); // add class for field header as field value
	$xt->assign("gas_mastervalue", $viewControls->showDBValue("gas", $data, $keylink));
	$format = $settings->getViewFormat("gas");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("gas")))
		$class = ' rnr-field-number';
		
	$xt->assign("gas_class", $class); // add class for field header as field value
	$xt->assign("water_mastervalue", $viewControls->showDBValue("water", $data, $keylink));
	$format = $settings->getViewFormat("water");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("water")))
		$class = ' rnr-field-number';
		
	$xt->assign("water_class", $class); // add class for field header as field value
	$xt->assign("cusa_mastervalue", $viewControls->showDBValue("cusa", $data, $keylink));
	$format = $settings->getViewFormat("cusa");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("cusa")))
		$class = ' rnr-field-number';
		
	$xt->assign("cusa_class", $class); // add class for field header as field value
	$xt->assign("monthly_rate_mastervalue", $viewControls->showDBValue("monthly_rate", $data, $keylink));
	$format = $settings->getViewFormat("monthly_rate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("monthly_rate")))
		$class = ' rnr-field-number';
		
	$xt->assign("monthly_rate_class", $class); // add class for field header as field value
	$xt->assign("advance_mastervalue", $viewControls->showDBValue("advance", $data, $keylink));
	$format = $settings->getViewFormat("advance");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("advance")))
		$class = ' rnr-field-number';
		
	$xt->assign("advance_class", $class); // add class for field header as field value
	$xt->assign("id_no_mastervalue", $viewControls->showDBValue("id_no", $data, $keylink));
	$format = $settings->getViewFormat("id_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("id_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("id_no_class", $class); // add class for field header as field value
	$xt->assign("issued_at_mastervalue", $viewControls->showDBValue("issued_at", $data, $keylink));
	$format = $settings->getViewFormat("issued_at");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("issued_at")))
		$class = ' rnr-field-number';
		
	$xt->assign("issued_at_class", $class); // add class for field header as field value
	$xt->assign("issued_on_mastervalue", $viewControls->showDBValue("issued_on", $data, $keylink));
	$format = $settings->getViewFormat("issued_on");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("issued_on")))
		$class = ' rnr-field-number';
		
	$xt->assign("issued_on_class", $class); // add class for field header as field value
	$xt->assign("payment_method_mastervalue", $viewControls->showDBValue("payment_method", $data, $keylink));
	$format = $settings->getViewFormat("payment_method");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("payment_method")))
		$class = ' rnr-field-number';
		
	$xt->assign("payment_method_class", $class); // add class for field header as field value
	$xt->assign("area_mastervalue", $viewControls->showDBValue("area", $data, $keylink));
	$format = $settings->getViewFormat("area");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("area")))
		$class = ' rnr-field-number';
		
	$xt->assign("area_class", $class); // add class for field header as field value
	$xt->assign("price_mastervalue", $viewControls->showDBValue("price", $data, $keylink));
	$format = $settings->getViewFormat("price");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("price")))
		$class = ' rnr-field-number';
		
	$xt->assign("price_class", $class); // add class for field header as field value
	$xt->assign("amount_mastervalue", $viewControls->showDBValue("amount", $data, $keylink));
	$format = $settings->getViewFormat("amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("amount_class", $class); // add class for field header as field value
	$xt->assign("check_no_mastervalue", $viewControls->showDBValue("check_no", $data, $keylink));
	$format = $settings->getViewFormat("check_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("check_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("check_no_class", $class); // add class for field header as field value
	$xt->assign("total_reservation_mastervalue", $viewControls->showDBValue("total_reservation", $data, $keylink));
	$format = $settings->getViewFormat("total_reservation");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("total_reservation")))
		$class = ' rnr-field-number';
		
	$xt->assign("total_reservation_class", $class); // add class for field header as field value
	$xt->assign("discount_mastervalue", $viewControls->showDBValue("discount", $data, $keylink));
	$format = $settings->getViewFormat("discount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_class", $class); // add class for field header as field value
	$xt->assign("discount_rate_mastervalue", $viewControls->showDBValue("discount_rate", $data, $keylink));
	$format = $settings->getViewFormat("discount_rate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_rate")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_rate_class", $class); // add class for field header as field value
	$xt->assign("discount_amount_mastervalue", $viewControls->showDBValue("discount_amount", $data, $keylink));
	$format = $settings->getViewFormat("discount_amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_amount_class", $class); // add class for field header as field value
	$xt->assign("no_of_months_mastervalue", $viewControls->showDBValue("no_of_months", $data, $keylink));
	$format = $settings->getViewFormat("no_of_months");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("no_of_months")))
		$class = ' rnr-field-number';
		
	$xt->assign("no_of_months_class", $class); // add class for field header as field value
	$xt->assign("telephone_mastervalue", $viewControls->showDBValue("telephone", $data, $keylink));
	$format = $settings->getViewFormat("telephone");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("telephone")))
		$class = ' rnr-field-number';
		
	$xt->assign("telephone_class", $class); // add class for field header as field value
	$xt->assign("no_of_months_advance_mastervalue", $viewControls->showDBValue("no_of_months_advance", $data, $keylink));
	$format = $settings->getViewFormat("no_of_months_advance");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("no_of_months_advance")))
		$class = ' rnr-field-number';
		
	$xt->assign("no_of_months_advance_class", $class); // add class for field header as field value
	$xt->assign("no_of_months_deposit_mastervalue", $viewControls->showDBValue("no_of_months_deposit", $data, $keylink));
	$format = $settings->getViewFormat("no_of_months_deposit");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("no_of_months_deposit")))
		$class = ' rnr-field-number';
		
	$xt->assign("no_of_months_deposit_class", $class); // add class for field header as field value
	$xt->assign("total_deposit_mastervalue", $viewControls->showDBValue("total_deposit", $data, $keylink));
	$format = $settings->getViewFormat("total_deposit");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("total_deposit")))
		$class = ' rnr-field-number';
		
	$xt->assign("total_deposit_class", $class); // add class for field header as field value
	$xt->assign("due_date_mastervalue", $viewControls->showDBValue("due_date", $data, $keylink));
	$format = $settings->getViewFormat("due_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("due_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("due_date_class", $class); // add class for field header as field value
	$xt->assign("price1_mastervalue", $viewControls->showDBValue("price1", $data, $keylink));
	$format = $settings->getViewFormat("price1");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("price1")))
		$class = ' rnr-field-number';
		
	$xt->assign("price1_class", $class); // add class for field header as field value
	$xt->assign("price2_mastervalue", $viewControls->showDBValue("price2", $data, $keylink));
	$format = $settings->getViewFormat("price2");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("price2")))
		$class = ' rnr-field-number';
		
	$xt->assign("price2_class", $class); // add class for field header as field value
	$xt->assign("price3_mastervalue", $viewControls->showDBValue("price3", $data, $keylink));
	$format = $settings->getViewFormat("price3");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("price3")))
		$class = ' rnr-field-number';
		
	$xt->assign("price3_class", $class); // add class for field header as field value
	$xt->assign("price4_mastervalue", $viewControls->showDBValue("price4", $data, $keylink));
	$format = $settings->getViewFormat("price4");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("price4")))
		$class = ' rnr-field-number';
		
	$xt->assign("price4_class", $class); // add class for field header as field value
	$xt->assign("price5_mastervalue", $viewControls->showDBValue("price5", $data, $keylink));
	$format = $settings->getViewFormat("price5");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("price5")))
		$class = ' rnr-field-number';
		
	$xt->assign("price5_class", $class); // add class for field header as field value
	$xt->assign("center_mastervalue", $viewControls->showDBValue("center", $data, $keylink));
	$format = $settings->getViewFormat("center");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("center")))
		$class = ' rnr-field-number';
		
	$xt->assign("center_class", $class); // add class for field header as field value
	$xt->assign("tel_amount_mastervalue", $viewControls->showDBValue("tel_amount", $data, $keylink));
	$format = $settings->getViewFormat("tel_amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("tel_amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("tel_amount_class", $class); // add class for field header as field value

	$layout = GetPageLayout("rent", 'masterprint');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');

	$xt->displayPartial(GetTemplateName("rent", "masterprint"));
}

?>