<?php
include_once(getabspath("classes/printpage.php"));

function DisplayMasterTableInfoForPrint_cusa($params)
{
	global $cman;
	
	$detailtable = $params["detailtable"];
	$keys = $params["keys"];
	
	$xt = new Xtempl();
	
	$tName = "cusa";
	$xt->eventsObject = getEventObject($tName);
	
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["pageType"] = PAGE_PRINT;
	$mParams["tName"] = $tName;
	$masterPage = new PrintPage($mParams);
	
	$cipherer = new RunnerCipherer( $tName );
	$settings = new ProjectSettings($tName, PAGE_PRINT);
	$connection = $cman->byTable( $tName );
	
	$masterQuery = $settings->getSQLQuery();
	$viewControls = new ViewControlsContainer($settings, PAGE_PRINT, $masterPage);
	
	$where = "";
	$keysAssoc = array();
	$showKeys = "";

	if( $detailtable == "cusa_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("cusa","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}

	if( $detailtable == "cusa_pdc_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("cusa","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}
	
	if( !$where )
		return;
	
	$str = SecuritySQL("Export", $tName );
	if( strlen($str) )
		$where.= " and ".$str;
	
	$strWhere = whereAdd( $masterQuery->m_where->toSql($masterQuery), $where );
	if( strlen($strWhere) )
		$strWhere= " where ".$strWhere." ";
		
	$strSQL = $masterQuery->HeadToSql().' '.$masterQuery->FromToSql().$strWhere.$masterQuery->TailToSql();
	LogInfo($strSQL);
	
	$data = $cipherer->DecryptFetchedArray( $connection->query( $strSQL )->fetchAssoc() );
	if( !$data )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));	
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["id"]));
	
	$xt->assign("id_mastervalue", $viewControls->showDBValue("id", $data, $keylink));
	$format = $settings->getViewFormat("id");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("id")))
		$class = ' rnr-field-number';
		
	$xt->assign("id_class", $class); // add class for field header as field value
	$xt->assign("stall_mastervalue", $viewControls->showDBValue("stall", $data, $keylink));
	$format = $settings->getViewFormat("stall");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("stall")))
		$class = ' rnr-field-number';
		
	$xt->assign("stall_class", $class); // add class for field header as field value
	$xt->assign("tenant_mastervalue", $viewControls->showDBValue("tenant", $data, $keylink));
	$format = $settings->getViewFormat("tenant");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("tenant")))
		$class = ' rnr-field-number';
		
	$xt->assign("tenant_class", $class); // add class for field header as field value
	$xt->assign("payment_type_mastervalue", $viewControls->showDBValue("payment type", $data, $keylink));
	$format = $settings->getViewFormat("payment type");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("payment type")))
		$class = ' rnr-field-number';
		
	$xt->assign("payment_type_class", $class); // add class for field header as field value
	$xt->assign("start_date_mastervalue", $viewControls->showDBValue("start date", $data, $keylink));
	$format = $settings->getViewFormat("start date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("start date")))
		$class = ' rnr-field-number';
		
	$xt->assign("start_date_class", $class); // add class for field header as field value
	$xt->assign("number_of_months_mastervalue", $viewControls->showDBValue("number of months", $data, $keylink));
	$format = $settings->getViewFormat("number of months");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("number of months")))
		$class = ' rnr-field-number';
		
	$xt->assign("number_of_months_class", $class); // add class for field header as field value
	$xt->assign("total_mastervalue", $viewControls->showDBValue("total", $data, $keylink));
	$format = $settings->getViewFormat("total");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("total")))
		$class = ' rnr-field-number';
		
	$xt->assign("total_class", $class); // add class for field header as field value
	$xt->assign("discount_mastervalue", $viewControls->showDBValue("discount", $data, $keylink));
	$format = $settings->getViewFormat("discount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_class", $class); // add class for field header as field value
	$xt->assign("discount_rate_mastervalue", $viewControls->showDBValue("discount_rate", $data, $keylink));
	$format = $settings->getViewFormat("discount_rate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_rate")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_rate_class", $class); // add class for field header as field value
	$xt->assign("net_amount_mastervalue", $viewControls->showDBValue("net_amount", $data, $keylink));
	$format = $settings->getViewFormat("net_amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("net_amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("net_amount_class", $class); // add class for field header as field value
	$xt->assign("discount_amount_mastervalue", $viewControls->showDBValue("discount_amount", $data, $keylink));
	$format = $settings->getViewFormat("discount_amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_amount_class", $class); // add class for field header as field value
	$xt->assign("area_mastervalue", $viewControls->showDBValue("area", $data, $keylink));
	$format = $settings->getViewFormat("area");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("area")))
		$class = ' rnr-field-number';
		
	$xt->assign("area_class", $class); // add class for field header as field value
	$xt->assign("rate_mastervalue", $viewControls->showDBValue("rate", $data, $keylink));
	$format = $settings->getViewFormat("rate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("rate")))
		$class = ' rnr-field-number';
		
	$xt->assign("rate_class", $class); // add class for field header as field value
	$xt->assign("end_date_mastervalue", $viewControls->showDBValue("end_date", $data, $keylink));
	$format = $settings->getViewFormat("end_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("end_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("end_date_class", $class); // add class for field header as field value

	$layout = GetPageLayout("cusa", 'masterprint');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');

	$xt->displayPartial(GetTemplateName("cusa", "masterprint"));
}

?>