<?php

/**
* getLookupMainTableSettings - tests whether the lookup link exists between the tables
*
*  returns array with ProjectSettings class for main table if the link exists in project settings.
*  returns NULL otherwise
*/
function getLookupMainTableSettings($lookupTable, $mainTableShortName, $mainField, $desiredPage = "")
{
	global $lookupTableLinks;
	if(!isset($lookupTableLinks[$lookupTable]))
		return null;
	if(!isset($lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField]))
		return null;
	$arr = &$lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField];
	$effectivePage = $desiredPage;
	if(!isset($arr[$effectivePage]))
	{
		$effectivePage = PAGE_EDIT;
		if(!isset($arr[$effectivePage]))
		{
			if($desiredPage == "" && 0 < count($arr))
			{
				$effectivePage = $arr[0];
			}
			else
				return null;
		}
	}
	return new ProjectSettings($arr[$effectivePage]["table"], $effectivePage);
}

/** 
* $lookupTableLinks array stores all lookup links between tables in the project
*/
function InitLookupLinks()
{
	global $lookupTableLinks;

	$lookupTableLinks = array();

	$lookupTableLinks["stall_tenant"]["electricity_detail.stall_no"]["edit"] = array("table" => "electricity_detail", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["electricity_detail.tenant"]["edit"] = array("table" => "electricity_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["gas_detail.stall_no"]["edit"] = array("table" => "gas_detail", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["gas_detail.tenant"]["edit"] = array("table" => "gas_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["water_detail.stall_no"]["edit"] = array("table" => "water_detail", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["water_detail.tenant"]["edit"] = array("table" => "water_detail", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["rent.stall"]["edit"] = array("table" => "rent", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["rent.tenant"]["edit"] = array("table" => "rent", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["reservation_type"]["rent.reservation"]["edit"] = array("table" => "rent", "field" => "reservation", "page" => "edit");
	$lookupTableLinks["discount"]["rent.discount"]["edit"] = array("table" => "rent", "field" => "discount", "page" => "edit");
	$lookupTableLinks["floor"]["stall.floor"]["edit"] = array("table" => "stall", "field" => "floor", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["cusa.stall"]["edit"] = array("table" => "cusa", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["cusa.tenant"]["edit"] = array("table" => "cusa", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["discount"]["cusa.discount"]["edit"] = array("table" => "cusa", "field" => "discount", "page" => "edit");
	$lookupTableLinks["bal_water"]["payment_detail_water.ref_id"]["edit"] = array("table" => "payment_detail_water", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["bal_gas"]["payment_detail_gas.ref_id"]["edit"] = array("table" => "payment_detail_gas", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["bal_electricity"]["payment_detail_electricity.ref_id"]["edit"] = array("table" => "payment_detail_electricity", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["bal_cusa"]["payment_detail_cusa.ref_id"]["edit"] = array("table" => "payment_detail_cusa", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["stall"]["CUSA_for_billing.stall"]["edit"] = array("table" => "CUSA_for_billing", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["CUSA_for_billing.tenant"]["edit"] = array("table" => "CUSA_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["electricity_for_billing.stall_no"]["edit"] = array("table" => "electricity_for_billing", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["electricity_for_billing.tenant"]["edit"] = array("table" => "electricity_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["Gas_for_billing.stall_no"]["edit"] = array("table" => "Gas_for_billing", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["Gas_for_billing.tenant"]["edit"] = array("table" => "Gas_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["Rent_for_billing.stall"]["edit"] = array("table" => "Rent_for_billing", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Rent_for_billing.tenant"]["edit"] = array("table" => "Rent_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall"]["Water_for_billing.stall_no"]["edit"] = array("table" => "Water_for_billing", "field" => "stall_no", "page" => "edit");
	$lookupTableLinks["tenant"]["Water_for_billing.tenant"]["edit"] = array("table" => "Water_for_billing", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["rent_payment.stall"]["edit"] = array("table" => "rent_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["rent_payment.tenant"]["edit"] = array("table" => "rent_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["CUSA_payment.stall"]["edit"] = array("table" => "CUSA_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["CUSA_payment.tenant"]["edit"] = array("table" => "CUSA_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["Gas_payment.stall"]["edit"] = array("table" => "Gas_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Gas_payment.tenant"]["edit"] = array("table" => "Gas_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["Electricity_payment.stall"]["edit"] = array("table" => "Electricity_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Electricity_payment.tenant"]["edit"] = array("table" => "Electricity_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["stall_tenant"]["Water_payment.stall"]["edit"] = array("table" => "Water_payment", "field" => "stall", "page" => "edit");
	$lookupTableLinks["tenant"]["Water_payment.tenant"]["edit"] = array("table" => "Water_payment", "field" => "tenant", "page" => "edit");
	$lookupTableLinks["bal_rent"]["payment_detail_rent.ref_id"]["edit"] = array("table" => "payment_detail_rent", "field" => "ref_id", "page" => "edit");
	$lookupTableLinks["stall"]["collection_Report.stall"]["search"] = array("table" => "collection_Report", "field" => "stall", "page" => "search");
	$lookupTableLinks["tenant"]["collection_Report.tenant"]["search"] = array("table" => "collection_Report", "field" => "tenant", "page" => "search");
	$lookupTableLinks["stall"]["Rent_Summary.stall"]["search"] = array("table" => "Rent_Summary", "field" => "stall", "page" => "search");
	$lookupTableLinks["tenant"]["Rent_Summary.tenant"]["search"] = array("table" => "Rent_Summary", "field" => "tenant", "page" => "search");
	$lookupTableLinks["reservation_type"]["Rent_Summary.reservation"]["search"] = array("table" => "Rent_Summary", "field" => "reservation", "page" => "search");
	$lookupTableLinks["discount"]["Rent_Summary.discount"]["search"] = array("table" => "Rent_Summary", "field" => "discount", "page" => "search");
	$lookupTableLinks["stall"]["rent_contract.stall"]["search"] = array("table" => "rent_contract", "field" => "stall", "page" => "search");
	$lookupTableLinks["tenant"]["rent_contract.tenant"]["search"] = array("table" => "rent_contract", "field" => "tenant", "page" => "search");
	$lookupTableLinks["reservation_type"]["rent_contract.reservation"]["search"] = array("table" => "rent_contract", "field" => "reservation", "page" => "search");
	$lookupTableLinks["discount"]["rent_contract.discount"]["search"] = array("table" => "rent_contract", "field" => "discount", "page" => "search");
}

?>